DROP TRIGGER IF EXISTS `update_project_hastime`;
delimiter ||
CREATE TRIGGER `update_project_hastime` AFTER INSERT ON `ld_projectprogress` FOR EACH ROW
BEGIN
	IF @disable_triggers IS NULL THEN 
		-- 项目
		if new.projectid > 0 then 
			select IFNULL(sum(timecost),0),IFNULL(sum(totalcost),0) into @timecost,@totalcost from ld_projectprogress where projectid = new.projectid and deleted = 0;
			update ld_project set hastime = @timecost,hascost = @totalcost where projectid = new.projectid;
		end if;
		-- 项目任务
		if new.projecttaskid > 0 then 
			select IFNULL(sum(timecost),0),IFNULL(sum(totalcost),0) into @timecost,@totalcost from ld_projectprogress where projecttaskid = new.projecttaskid and deleted = 0;
			update ld_projecttask set hastime = @timecost,hascost = @totalcost where projecttaskid = new.projecttaskid;
		end if;
	end if;
END ||
delimiter;



DROP TRIGGER IF EXISTS `update_project_hastime2`;
delimiter ||
CREATE TRIGGER `update_project_hastime2` AFTER UPDATE ON `ld_projectprogress` FOR EACH ROW
BEGIN
	IF @disable_triggers IS NULL THEN 
		-- 项目
		if new.projectid > 0 then 
			select IFNULL(sum(timecost),0),IFNULL(sum(totalcost),0) into @timecost,@totalcost from ld_projectprogress where projectid = new.projectid and deleted = 0;
			update ld_project set hastime = @timecost,hascost = @totalcost where projectid = new.projectid;
		end if;
		if new.projectid > 0 and OLD.projectid > 0 and new.projectid <> OLD.projectid then 
			select IFNULL(sum(timecost),0),IFNULL(sum(totalcost),0) into @timecost,@totalcost from ld_projectprogress where projectid = OLD.projectid and deleted = 0;
			update ld_project set hastime = @timecost,hascost = @totalcost where projectid = OLD.projectid;
		end if;
		-- 项目任务
		if new.projecttaskid > 0 then 
			select IFNULL(sum(timecost),0),IFNULL(sum(totalcost),0) into @timecost,@totalcost from ld_projectprogress where projecttaskid = new.projecttaskid and deleted = 0;
			update ld_projecttask set hastime = @timecost,hascost = @totalcost where projecttaskid = new.projecttaskid;
		end if;
		if new.projecttaskid > 0 and OLD.projecttaskid > 0 and new.projecttaskid <> OLD.projecttaskid then 
			select IFNULL(sum(timecost),0),IFNULL(sum(totalcost),0) into @timecost,@totalcost from ld_projectprogress where projecttaskid = OLD.projecttaskid and deleted = 0;
			update ld_projecttask set hastime = @timecost,hascost = @totalcost where projecttaskid = OLD.projecttaskid;
		end if;
	end if;
END ||
delimiter;